// C Source File
// Created 3/29/2002; 23.34.02

#define USE_TI89              // Produce .89z File

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files


//Functions:
void beginExecution();
void inputData();
void solve();
void displayResults();

//Variables:
double a,b,c, val1, val2, imaginaryval;

// Main Function
void _main(void)
{
	beginExecution();
	inputData();
	solve();
	displayResults();
	ngetchx();
}

void beginExecution()
{
	clrscr();
	imaginaryval = 0;
	FontSetSys(F_8x10);
	printf("Quadratic Solver\n");
	FontSetSys(F_6x8);
	printf("By Mike Shvarts\n\n");
}

void inputData()
{
	char inputa[23], inputb[23], inputc[23];
	while (inputa[0] == 0)
	{
		printf("Enter a: ");
		gets(inputa);	
	}
	while (inputb[0] == 0)
	{
		printf("Enter b: ");
		gets(inputb);
	}
	while (inputc[0] == 0)
	{
		printf("Enter c: ");
		gets(inputc);
	}
	a = atof(inputa);
	b = atof(inputb);
	c = atof(inputc);
}	

void solve()
{
	double discriminant=0;
	discriminant = (pow(b,2) + (-4*a*c));
	
	val1 = (-b + sqrt(discriminant)) / (2*a);	
	val2 = (-b - sqrt(discriminant)) / (2*a);		
	//pow(b,2) + (-4*a*c))
	if (discriminant < 0)
	{
		//printf ("Discriminent is:"); printf("%f", discriminant);
		imaginaryval = sqrt(-discriminant) / (2*a);
	}
	
} 
	

void displayResults()
{
	printf("\nThe solution set is: \n\n");
	printf("{ "); printf("%f", val1);
	if ( imaginaryval > 0 )
	{
		printf("+"); printf("%f",imaginaryval); printf("i");
		printf(" , ");
		printf("%f", val1); printf("-"); printf("%f",imaginaryval); printf( "i }");
	}
	else
	{
		if (val1 == val2)
		{
		printf(" }");
		}
		else
		{
		printf(" , "); printf("%f", val2); printf(" }"); 
		}
	}
}
